/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.ltl.core.parser.lexer;

import java.io.*;
import java.util.*;
import de.be4.ltl.core.parser.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.LTL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.ACTION; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.ACTION; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.ACTION; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.ATOMIC; break;
                                case 0: state = State.ATOMIC; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.ATOMIC; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.ATOMIC; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.ACTION; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.ACTION; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.ACTION; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.ACTION; break;
                            }
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.ACTION; break;
                            }
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 28:
                        {
                              Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 29:
                        {
                              Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 30:
                        {
                              Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 31:
                        {
                              Token token = new31(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 32:
                        {
                              Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 33:
                        {
                              Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 34:
                        {
                              Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.LTL; break;
                            }
                            return token;
                        }
                    case 35:
                        {
                              Token token = new35(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  int line,   int pos) { return new TTrue(line, pos); }
    Token new1(  int line,   int pos) { return new TFalse(line, pos); }
    Token new2(  int line,   int pos) { return new TSink(line, pos); }
    Token new3(  int line,   int pos) { return new TDeadlock(line, pos); }
    Token new4(  int line,   int pos) { return new TCurrent(line, pos); }
    Token new5(  String text,   int line,   int pos) { return new TLPar(text, line, pos); }
    Token new6(  String text,   int line,   int pos) { return new TRPar(text, line, pos); }
    Token new7(  String text,   int line,   int pos) { return new TLSq(text, line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TEnabled(text, line, pos); }
    Token new9(  String text,   int line,   int pos) { return new TAvailable(text, line, pos); }
    Token new10(  String text,   int line,   int pos) { return new TAtomicPropositionBegin(text, line, pos); }
    Token new11(  String text,   int line,   int pos) { return new TAtomicPropositionEnd(text, line, pos); }
    Token new12(  String text,   int line,   int pos) { return new TApChar(text, line, pos); }
    Token new13(  String text,   int line,   int pos) { return new TActionEnd(text, line, pos); }
    Token new14(  String text,   int line,   int pos) { return new TActionBegin(text, line, pos); }
    Token new15(  String text,   int line,   int pos) { return new TTpChar(text, line, pos); }
    Token new16(  String text,   int line,   int pos) { return new TExistsIdentifier(text, line, pos); }
    Token new17(  String text,   int line,   int pos) { return new TForallIdentifier(text, line, pos); }
    Token new18(  int line,   int pos) { return new TImplies(line, pos); }
    Token new19(  int line,   int pos) { return new TAnd(line, pos); }
    Token new20(  int line,   int pos) { return new TOr(line, pos); }
    Token new21(  int line,   int pos) { return new TNot(line, pos); }
    Token new22(  String text,   int line,   int pos) { return new TStrongFair(text, line, pos); }
    Token new23(  String text,   int line,   int pos) { return new TWeakFair(text, line, pos); }
    Token new24(  int line,   int pos) { return new TUntil(line, pos); }
    Token new25(  int line,   int pos) { return new TWeakuntil(line, pos); }
    Token new26(  int line,   int pos) { return new TRelease(line, pos); }
    Token new27(  int line,   int pos) { return new TGlobally(line, pos); }
    Token new28(  int line,   int pos) { return new TFinally(line, pos); }
    Token new29(  int line,   int pos) { return new TNext(line, pos); }
    Token new30(  int line,   int pos) { return new TSince(line, pos); }
    Token new31(  int line,   int pos) { return new TTrigger(line, pos); }
    Token new32(  int line,   int pos) { return new THistorically(line, pos); }
    Token new33(  int line,   int pos) { return new TOnce(line, pos); }
    Token new34(  int line,   int pos) { return new TYesterday(line, pos); }
    Token new35(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // LTL
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 33, 3}, {35, 35, 4}, {38, 38, 5}, {40, 40, 6}, {41, 41, 7}, {61, 61, 8}, {65, 65, 9}, {70, 70, 10}, {71, 71, 11}, {72, 72, 12}, {79, 79, 13}, {82, 82, 14}, {83, 83, 15}, {84, 84, 16}, {85, 85, 17}, {87, 87, 18}, {88, 88, 19}, {89, 89, 20}, {91, 91, 21}, {99, 99, 22}, {100, 100, 23}, {101, 101, 24}, {102, 102, 25}, {110, 110, 26}, {111, 111, 27}, {115, 115, 28}, {116, 116, 29}, {123, 123, 30}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 8233, -2}, },
            {},
            {{0, 9, 31}, {10, 10, 32}, {11, 12, 31}, {13, 13, 32}, {14, 32, 31}, {65, 90, 33}, {97, 122, 34}, {127, 160, 31}, {8206, 8207, 31}, {8232, 8233, 31}, },
            {{0, 9, 35}, {10, 10, 36}, {11, 12, 35}, {13, 13, 36}, {14, 32, 35}, {65, 90, 37}, {97, 122, 38}, {127, 160, 35}, {8206, 8207, 35}, {8232, 8233, 35}, },
            {},
            {},
            {},
            {{62, 62, 39}, },
            {{118, 118, 40}, },
            {},
            {},
            {},
            {},
            {},
            {{70, 70, 41}, },
            {},
            {},
            {{70, 70, 42}, },
            {},
            {},
            {},
            {{117, 117, 43}, },
            {{101, 101, 44}, },
            {{40, 40, 45}, },
            {{97, 97, 46}, },
            {{111, 111, 47}, },
            {{114, 114, 48}, },
            {{105, 105, 49}, },
            {{114, 114, 50}, },
            {},
            {{0, 8233, -5}, },
            {{0, 8233, -5}, },
            {{0, 9, 51}, {10, 10, 52}, {11, 12, 51}, {13, 13, 52}, {14, 32, 51}, {46, 46, 53}, {48, 57, 54}, {65, 90, 55}, {95, 95, 56}, {97, 122, 57}, {127, 160, 51}, {8206, 8207, 51}, {8232, 8233, 51}, },
            {{0, 8233, -35}, },
            {{0, 8233, -6}, },
            {{0, 8233, -6}, },
            {{0, 9, 58}, {10, 10, 59}, {11, 12, 58}, {13, 13, 59}, {14, 32, 58}, {46, 46, 60}, {48, 57, 61}, {65, 90, 62}, {95, 95, 63}, {97, 122, 64}, {127, 160, 58}, {8206, 8207, 58}, {8232, 8233, 58}, },
            {{0, 8233, -39}, },
            {},
            {{40, 40, 65}, },
            {{40, 40, 66}, },
            {{40, 40, 67}, },
            {{114, 114, 68}, },
            {{97, 97, 69}, },
            {},
            {{108, 108, 70}, },
            {{116, 116, 71}, },
            {},
            {{110, 110, 72}, },
            {{117, 117, 73}, },
            {{0, 46, -35}, {127, 8233, -35}, },
            {{0, 8233, -53}, },
            {},
            {{0, 8233, -35}, },
            {{0, 8233, -35}, },
            {{0, 8233, -35}, },
            {{0, 8233, -35}, },
            {{0, 46, -39}, {127, 8233, -39}, },
            {{0, 8233, -60}, },
            {},
            {{0, 8233, -39}, },
            {{0, 8233, -39}, },
            {{0, 8233, -39}, },
            {{0, 8233, -39}, },
            {},
            {},
            {},
            {{114, 114, 74}, },
            {{100, 100, 75}, },
            {{115, 115, 76}, },
            {},
            {{107, 107, 77}, },
            {{101, 101, 78}, },
            {{101, 101, 79}, },
            {{108, 108, 80}, },
            {{101, 101, 81}, },
            {},
            {},
            {{110, 110, 82}, },
            {{111, 111, 83}, },
            {},
            {{116, 116, 84}, },
            {{99, 99, 85}, },
            {},
            {{107, 107, 86}, },
            {},
        }
        { // ATOMIC
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 122, 3}, {123, 123, 4}, {124, 124, 3}, {125, 125, 5}, {126, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 6}, {11, 12, 6}, {14, 32, 6}, {127, 160, 6}, {8206, 8207, 6}, {8232, 8233, 6}, },
            {},
            {},
            {},
            {},
            {{0, 8233, -3}, },
        }
        { // ACTION
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 39, 3}, {40, 40, 4}, {41, 41, 5}, {42, 90, 3}, {91, 91, 4}, {92, 92, 3}, {93, 93, 5}, {94, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 6}, {11, 12, 6}, {14, 32, 6}, {127, 160, 6}, {8206, 8207, 6}, {8232, 8233, 6}, },
            {},
            {},
            {},
            {},
            {{0, 8233, -3}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // LTL
        {-1, 35, 35, -1, -1, 19, 5, 6, -1, -1, 28, 27, 32, 33, 26, 30, 31, 24, 25, 29, 34, 7, -1, -1, -1, -1, -1, -1, -1, -1, 10, -1, -1, -1, -1, -1, -1, -1, -1, 18, -1, -1, -1, -1, -1, 8, -1, -1, 20, -1, -1, -1, -1, 17, -1, -1, -1, -1, -1, -1, 16, -1, -1, -1, -1, 9, 22, 23, -1, -1, -1, 21, -1, -1, -1, -1, -1, 2, 0, -1, -1, 1, -1, -1, 4, -1, 3, },
        // ATOMIC
        {-1, 12, 12, 12, 10, 11, 35, },
        // ACTION
        {-1, 15, 15, 15, 14, 13, 35, },

    };*/

    public static class State
    {
        public final static State LTL = new State(0);
        public final static State ATOMIC = new State(1);
        public final static State ACTION = new State(2);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
